
/************************************************************************
 *                   C-SaCzech 1.23   (c) Jaromir Dolecek               *
 *                 program pro zmenu kodovani WWW dokumentu             *
 ************************************************************************
	Puvod ma v programu SaCzech 2.0 od pana Pavla Satrapy (kontakt
	email -  Pavel.Satrapa@vslib.cz, WWW -
	http://otus.kin.vslib.cz/cgi-bin/whichcode/~satrapa/sw/saczech/index.html).

	Dokumentace C-Saczechu a dalsi informace k programu jsou na
	  http://www.fi.muni.cz/~dolecek/c-saczech/
	Autora C-Saczechu je mozno kontaktovat pres e-mail na adrese
	  dolecek@fi.muni.cz

	Tento program je freeware - muzete volne pouzivat, menit a kopirovat
	kteroukoli cast programu nebo soucast baleni C-SaCzechu. Autor se zrika
	jakekoli zodpovednosti za skody plynouci z uzivani tohoto programu.
	Pamatujte vsak, ze vytvoreni tohoto dila stalo nemale usili,
	a proto prosim o jakemkoli takovem pouziti informujte
	autora na vyse uvedene emailove adrese.
*/

/* nacteni souboru kontant = 'constant.c' je upravovan skriptem 'makeit'
 * proto neni vhodne do nej prilis zasahovat */

#include "constant.h"

/* knihovna pro propojeni na HTTP */
#include "cgic.h"

/* a nyni vlastni kod programu */

#include "csawww.h"	/* potrebne funkce pro komunikaci a srovnavani */
#include "cstools.h"  	/* prevody mezi ruznymi typy kodovani */
#include <time.h>
#include <signal.h>

#define EncodeLine(XX)		cs_encode( XX, source, target)

/* pole uchovavajici pripustne pripony a kodovani */
/* vyznam radku je:   pripona souboru, odpovidajici kodovani */
const char * ext[] = 
{ 
	  "cz",   	"text/html",
	  "html",	"text/html",
	  "htm",	"text/html",
	  "txt",	"text/plain",
	  "",		""
};

/* definovani nekterych zakladnich kontant - delky bufferu */
#define LITTLEBUFLEN		512
#define LARGEBUFLEN		2048
#define BARBUFLEN		LARGEBUFLEN
#define BARSEPBUFLEN		LITTLEBUFLEN

/* globalni promenne */
static int source, target, fcode = 1;
static char pname[LITTLEBUFLEN], query[LARGEBUFLEN];

static char *path_info, *path_translated, *server_name, *server_port,
	*script_name, *content_length, *request_method;

#define NOCODE		"<!--NOCODE-->"
#define CODE		"<!--CODE-->"
#define COMMEND		"-->"

/* promenne pouzivane MakeBar a fadded v EncodeHTTP, EncodeFile */
#ifdef ADDBAR

#define BARPREFIX	"<!--BAR"

  static char bar[BARBUFLEN];
  static char barsep[BARSEPBUFLEN];
  static int flongname, falwaysaddbar, faddwhichcode, fenglish, ftitle, fback;
  static int fadded = 0;
#endif

#ifdef MULTIPART 
/* promenna urcujici, ktera cast dokumentu se ma zobrazit */
/* jen pro MULTIPART */

static char partname[LITTLEBUFLEN];
static int fprint = 1;

#define PARTPREFIX	"<!--PART"

#endif


/* pro urceni, zda je pripona souboru platna (ma se prek.) */
/* popr zda dany mime typ je urcen k prekodovani */
#define ISEXT( XX ) 		(testmime( XX, 0 )>-1)
#define ISMIME( XX )		(testmime( XX, 1 )>-1)

/* definice funkci */
int SetBarDef();

/*
 * pro testovani spravneho mime typu, zda dana pripona je urcena ke kodovani
 * pouziva pole 'ext'
 */
int testmime( const char * exte, int start )
{
	int i;
   
   if ( exte == NULL ) return FALSE;

   for(i=start; ext[i][0] ; i+=2)
		if (!stricmp(exte,ext[i])) return i;

	return -1;
}


/*
 * vypsani chybove zpravy klientovi
 */
void http_perr( char * txt )
{
  fprintf(cgiOut,"Content-type: text/html\n\n");
  fprintf(cgiOut,"<HTML><BODY><H3>%s</H3></BODY></HTML>\n", txt );
}


/*
 * procedura pro zachyceni signalu Alarm Call - delal trochu neporadek, pokud
 * dokument neni dostupny
 */
void alarmtrap()
{
  http_perr( "C-SaCzech: No respond" );
  fprintf(cgiOut,"Local error - cannot contact server within time limit.\n");
  exit(0);
}


/*
 * zmeni si vnitrni kodovani - line musi obsahovat neco ve tvaru
 * <!--MYCHARSET=kod-->
 */
int newcharset( char * line )
{
	static char *a, b[LITTLEBUFLEN], *c;

	if ( line == NULL )
	return FALSE;

	strcpy( b, line );
 /*
  *  najde zacatek retezce urcujiciho novy kod ,
  *  vymaze deklaracni cast a nakonec odrizne vse od '-->'
  */
	if ( ( a = strstr( b, "<!--MYCHARSET=" ) ) == NULL ) return FALSE;
	a += strlen( "<!--MYCHARSET=" ) * sizeof( char );
	if ( ( c = strstr( a, COMMEND ) ) == NULL ) return FALSE;
	*c = '\0';

	/* pokud se jedna o spatne jmeno kodu, nastavi default kod */
	source = whichcode(a);
	if (source==-1) { source = whichcode( DEFSOURCE ); return FALSE; }

	return TRUE;
}


#ifdef ADDBAR

/* nastaveni glob. promennych podle pripadnych parametru u <!--BAR */
int SetBarVar( char * comm )
{
	char *a, b[LITTLEBUFLEN];
	int fout=1;

	if ( comm == NULL ) return 0;

	a = strcaseinfix( comm, "DEF" ); /* prikaz BARDEF jen definuje tvar BARu*/
	if ( a != NULL && a == comm ) { fout = 0; comm += strlen("DEF"); }

	while(get_pparam(comm,b,' '))
	{
	  if (!stricmp(b, "LONG")) flongname = 1;
	  else if (!stricmp(b, "SHORT")) flongname = 0;
	  else if (!stricmp(b, "WHICH")) faddwhichcode = 1;
	  else if (!stricmp(b, "NOWHICH")) faddwhichcode = 0;
	  else if (!stricmp(b, "E")) fenglish = 1;
	  else if (!stricmp(b, "CZ")) fenglish = 0;
	  else if (!stricmp(b, "NOBAR")) falwaysaddbar = 0;
	  else if (!stricmp(b, "ALWAYS")) falwaysaddbar = 1;
	  else if (strcaseinfix(b, "SEP=")==b)
	  {
	split_pparam(b, FALSE, '=');
	strcpy( barsep, b );
	  }
	  else if (!stricmp(b, "DEFAULT")) SetBarDef();
	  else if (!stricmp(b, "NOTITLE")) ftitle = 0;
	  else if (!stricmp(b, "TITLE")) ftitle = 1;
	  else if (!stricmp(b, "NOBACK")) fback = 0;
	  else if (!stricmp(b, "BACK")) fback = 1;
	}

	return fout;
}

/*
 * vytvoreni listy s nabidkou kodovani
 */
int MakeBar( char * bar, char * line )
{
	int i,j;
	static char buff[LITTLEBUFLEN], a[LARGEBUFLEN], *b, *c;

	/* precteni pripadnych parametru u <!--BAR a nastaveni */
	/* glob. promm.					  */
	if ( line != NULL )
	{
	  b = strcaseinfix(line, BARPREFIX);
	  c = strstr(line, COMMEND);
	  if ( c == NULL || c < b ) return 0;
	  i = strlen(BARPREFIX);
	  memcpy(a, b+i, c-b+i );
	  a[c-b+i] = '\0';
	  if (!SetBarVar( a )) return 0;
	}

	bar[0] = '\0';
	if (ftitle)
	{
	  if (!fenglish)
		 sprintf( bar, "%s\n", HEADBARTEXT );
	  else
		 sprintf( bar, "%s\n", EHEADBARTEXT );
	}

	strcpy( a, script_name );
	b = path_info;
	j = whichcode( pname );    /* ciselne oznaceni typu ciloveho kodu */
	for(i=0;i<POCF; i++)
	{
		if ( i>0 ) subs( a, TRUENAME(i-1), TRUENAME(i) );
		else if (i!=j) subs( a, pname, TRUENAME(i) );

		sprintf( buff, "<A HREF=%s%s%s>%s</A> %s \n", a, b, query,
	(flongname) ? CODENAME(i) : ABBRNAME(i),
			(i < POCF-1) ? barsep : "" );

		strcat( bar, buff );
	}

	if (faddwhichcode)
	{
	  sprintf( buff, "%s", TRUENAME(i-1) );
	  subs( a, buff, "whichcode" );
	  sprintf( buff, "%s <A HREF=%s%s%s>%s</A>\n",
	barsep, a,b,query, BARWHICHCODENAME );
	  strcat( bar, buff );
	}

	if (fback)
	{
	  if (!fenglish)
		 strcat( bar, TAILBARTEXT );
	  else
		 strcat( bar, ETAILBARTEXT );
	}
	return 1;
}
#endif


/*
 * zpracuje jednu radku vstupu; vytvorena v ramci zjednoduseni
 * struktury programu( predtim duplikace v EncodeHTTP a EncodeFile)
 */
int ProceedLine( char * line )
{
	static char *a, *b, c, buff[LITTLEBUFLEN];
	static int i;

	/* nic nebylo dodano, co delat */
	if ( line == NULL ) return 0;

	/* zpracovani prikazu */
	/* je v radce komentar? */
	if (strcaseinfix( line, "<!--") )
	{
#ifdef MULTIPART
	  if ( ( a = strcaseinfix( line, PARTPREFIX ) ) != 0)
	  {
			a += strlen( PARTPREFIX );
			while( *a == ' ' || *a == '	' ) a++;
			strcpy( buff, a );
			b = strstr( buff, COMMEND );
			*b = '\0';
			if (!stricmp( buff, partname )||!stricmp( buff, "ALL" ))
		 fprint = 1;
			else fprint = 0;
	  }

	  else if (fprint && strcaseinfix( line, NOCODE )) fcode = 0;
	  else if (fprint && strcaseinfix( line, CODE )) fcode = 1;
#else
	  if (strcaseinfix( line, NOCODE )) fcode = 0;
	  else if (strcaseinfix( line, CODE )) fcode = 1;
#endif
	  else if (strcaseinfix( line, "MYCHARSET")) newcharset( line );
#ifdef ADDBAR
	  /* ma se sem pridat BAR */
	 else if (strcaseinfix( line, BARPREFIX )
#ifdef MULTIPART
			&&fprint
#endif
		 )
	  {
		 if (MakeBar(bar, line))
		 {
			a = strcaseinfix( line, BARPREFIX );
			b = strstr( line, COMMEND );
			i = strlen( COMMEND);
			c = b[i]; b[i] = '\0';
	 strcpy( buff, a );
			b[i] = c;

			subs( line, buff, bar );
			fadded++;
		 }
	  }
#endif
	}

#ifdef MULTIPART
	if (fprint)
	{
#endif

	  if (strstr( line, "CHARSET" ) )
	  {
		 if (strstr( line, "__CHARSET__" ) )
		  subs( line, "__CHARSET__", TRUENAME(target) );
	  }

	  /* dekoduj linku pokud to je potreba */
	  if (fcode) EncodeLine(line);
	  fprintf(cgiOut, "%s", line );
#ifdef MULTIPART
	}
#endif

	return 1;
}


#if defined(guess) || defined(file)

const char * days [] =
  { "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };
const char * months [] =
  { "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct",
	 "Nov", "Dec" };

int MakeHeaders(char *filename, char *extt)
{
  int i;
#ifdef TIMESERVICES
  struct tm tmi;
  struct stat buff;
  char *a, *b;
  char *g, buf1[LARGEBUFLEN], buf2[LARGEBUFLEN];

  stat(filename, &buff);
  memcpy( &tmi, localtime(&buff.st_mtime), sizeof(tmi) );

#ifdef IFMODIFIEDSINCE
  b = getenv("HTTP_IF_MODIFIED_SINCE");
  if ( b != NULL )
  {
	 a = strchr(b,','); g=b;
	 while(*g!='\0' && *g != ' ') g++;

	 if ( g == a || b[3] == *a || &b[3] == g )
	 {
	char c[2], d[8], e[3], f[4];
	int year,day;

	sscanf( a, "%s %s %s %s", c, e, f, d );
		  year=atoi(f);
	if ( g!=&b[3] )
	  if ( year >70 ) year += 1900;
	  else year +=2000;

	day=atoi(c);
		  for( i=0; i<12; i++ )
			 if ( strstr(e, months[i]) ) break;
	sprintf( buf1, "%d %02d %02d %s", year, i, day, d );
	 }

	 sprintf( buf2, "%d %02d %02d %02d:%02d:%02d", tmi.tm_year, tmi.tm_mon,
	tmi.tm_mday, tmi.tm_hour, tmi.tm_min, tmi.tm_sec );

	 if (!strcmp(buf1,buf2))
	 {
	printf( "Status: 304 Not modified\n" );
	exit(0);
	 }
  }
#endif
#endif

  for(i=0; i<4; i+=2)
	 if ( !stricmp(extt, ext[i] ) ) break;
  fprintf(cgiOut, "Content-Type: %s\n", ext[i+1] );
#ifdef TIMESERVICES

#ifndef ADDBAR
  fprintf(cgiOut, "Content-Length: %ld\n", buff.st_size );
#endif
  fprintf(cgiOut, "Last-Modified: %s, %02d %s %d %02d:%02d:%02d GMT\n",
	days[tmi.tm_wday], tmi.tm_mday, months[tmi.tm_mon], tmi.tm_year+1900,
	tmi.tm_hour, tmi.tm_min, tmi.tm_sec );
#endif
  fprintf(cgiOut, "\n" );
  return 1;
}

int EncodeFile()
{
  char pagefile[LARGEBUFLEN], buf[LARGEBUFLEN], *b;
  int i;
  FILE *fd;

#ifdef ADDBAR
  char bar[BARBUFLEN];
#endif

  path_translated = cgiPathTranslated;

  if ( ( b = path_translated ) == NULL ) return FALSE;
  /* zjistene jmeno HTML uloz do promene */
  strcpy( pagefile, b );

  /* je jmeno jenom directory? */
  if (isdir(pagefile))
  {
	 i=strlen(pagefile);
	 if ( pagefile[i-1] != '/' )
	 {
		pagefile[i] = '/';
		pagefile[i+1] = '\0';
	 }
	 /* pridej standardni nazev souboru (default.htm) */
	 strcat( pagefile, DEFAULTFILE );
  }

  /* kodovat ci nekodovat ? to je ta otazka */
  /* rozhoduje koncovka (pokud je) */
  if ( ( b = strrchr(pagefile, '.') ) != NULL )
	 b++;

  if ( !b || !ISEXT(b) )
  {
	  /* POZOR! query neni definovano (asi) */
	  fprintf(cgiOut, "Status: 301 Moved permanently\n" );
	  fprintf(cgiOut, "Location: http://%s:%s%s%s\n\n", cgiServerName,
	  cgiServerPort, cgiPathTranslated, query );
	  return TRUE;
  }

  /* otevri danz soubor na cteni */
  if ( ( fd = fopen( pagefile, "r" ) ) == NULL )
  {
	  fprintf(cgiOut, "Status: 404 Not Found\n" );
	  fprintf(cgiOut, "Content-type: text/html\n\n" );
	  fprintf(cgiOut, "<H1>Not Found</H1>\nThe requested object does not exist on this server. \nThe link you followed is either outdated, inaccurate, or the server\nhas been instructed not to let you have it." );
	  /* nepostestilo se */
	  return FALSE;
  }

  /* vytvor hlavicku HTTP */
  if (!MakeHeaders(pagefile, b)) return 0;

  buf[0] = '\0';

  /* provadej preklad po radkach */
  while(fgets(buf, LITTLEBUFLEN, fd )!=NULL)
		ProceedLine( buf );

  /* pridat rozhodovaci radek */
#ifdef ADDBAR
  if (falwaysaddbar)
  {
	  MakeBar( bar, NULL );
	  fprintf(cgiOut, "%s", bar );
  }
#endif

  /* uyavrit soubor */
  fclose(fd);
  return TRUE;
}

#endif

#if defined(http) || defined(guess)

void SendHTTPHeaders( FILE *fd, char *env[] )
{
	char *j, *k, buf1[LARGEBUFLEN];

	while( *env )
	{
		if ( str_prefix( *env, "HTTP_" ) )
		{
	strcpy( buf1, *env );
	k = buf1;
	j = strchr( buf1, '=' );
	if ( j == NULL ) continue;
	*(j++) = '\0';		   /* nyni j ukazuje na obsah promenne */
	if ( *j == '\0' ) continue;/* pokud promenna nema obsah, preskocit */
	subs( buf1, "HTTP_", "" ); /* odstraneni uvodniho HTTP_ */
	subs( buf1, "_", "-" );
		  for( ; *k ; k++ ) *k = UPPER(*k); /* prevedeni na velka pismena */

	fprintf( fd, "%s: %s\n", buf1, j );
		}
		env++;
	}
}

int EncodeHTTP( char * env[] )
{
	FILE *fd;
	char *host,*request, *a;
	int port,sock,convert=0;
	char buf[LARGEBUFLEN];

	server_name = cgiServerName;
	server_port = cgiServerPort;
	request_method = cgiRequestMethod;

	host = server_name;
	a = server_port;
	request = path_info;
	if ( !host || !a || !request_method )
	{
		http_perr( "C-SaCzech: Server error" );
		fprintf(cgiOut, "Variables set badly, you may contact administrator of \
	that site.\n" );
		return -1;
	}
	port=atoi(a);

	/* vyporadani se s requestem - pokud nebyla nastavena cesta ci pokud */
	/* cesta ukazuje na adresar */
	if ( request == NULL || *request == '\0' )
	{
		request = (char *) malloc (sizeof(char) * 2 );
		request[0] = '/';
		request[1] = '\0';
	}
	if ( request[strlen(request)-1] == '/' )
		strcat( request, DEFAULTFILE );

	sock = connect_server( host, port );
	if (sock < 0 )
	{
		http_perr( "Error in communication" );
		fprintf(cgiOut, "Cannot connect server %s, port %d\n", host, port );
		return sock;
	}

	if ( ( fd = fdopen( sock, "w" ) ) == NULL )
	{
		http_perr( "Local error" );
		fprintf(cgiOut, "Cannot open stream for socket communications.\n");
		exit(0);
	}

	alarm(30); /* po dvaceti sec dojde k preruseni */
	/* spojeni s WWW serverem */

	sprintf( buf, "%s %s%s HTTP/1.0\n", request_method,
	request, query );
	fputs( buf, fd );

	/* posle vsechny HTTP hlavicky predane jako parametry pri spusteni */
	/* nepatri totiz c-sacku, ale (vetsinou) maji vyznam pro spousteny */
	/* cgi skript */
	SendHTTPHeaders( fd, env );

	/* Podpora metody POST */
	/* spoustenemu skriptu se musi take poslat na stdin muj stdin */
	if (strcaseinfix(request_method, "POST" ) )
	{
		char *j;
		int i;

		i = atoi( content_length = getenv("CONTENT_LENGTH") );
		if ( i <= 0 )
		{
	http_perr("C-SaCzech: Server error");
	fprintf(cgiOut,"Environment variable CONTENT_LENGTH set badly.\n");
	exit(0);
		}

		fprintf(cgiOut, "Content-Length: %s\n", content_length );
		fprintf(cgiOut, "Content-Type: %s\n\n", getenv("CONTENT_TYPE") );
		i *= sizeof( char );
		j = (char *) malloc ( i );
		gets(j);
#ifdef DECODEQUERY
		EncodeLine( j );
#endif
		fputs(j, fd);
	}
	else fprintf( fd, "\n");
	/* tim je hotova hlavicka  a muze se cist */

	fflush( fd ); /* vyprazdneni obsahu print bufferu a otevreni pro cteni */

	if ( ( fd = fdopen( sock, "r" ) ) == NULL )
	{
		http_perr( "C-SaCzech: Local error" );
		fprintf(cgiOut, "Cannot open stream for socket communication\n");
		exit(0);
	}
	fgets( buf, LARGEBUFLEN, fd );

	alarm(0); /* vynulovani alarm casovace */

	if ( strcaseinfix( buf, "HTTP/" ) == buf)
	{  /* HTTP/1.0 */
		fprintf(cgiOut, "Status: %s", buf );
		while (fgets(buf, LARGEBUFLEN, fd) && strstr(buf, "\n" )!=buf )
		{
	subs( buf, "__CHARSET__", TRUENAME(target) );
		  printf( "%s", buf );
	if (strcaseinfix(buf, "Content-Type"))
	{
	  split_pparam(buf, FALSE, ' ');
	  *strstr(buf, "\n") = '\0';
	  if (ISMIME(buf)) convert=1;
	}
		}
		fprintf(cgiOut,"\n");
	} else /* HTTP/0.9 */
		fprintf(cgiOut, "%s", buf );

  if (convert)
  {
	while(fgets(buf, LARGEBUFLEN, fd)!=NULL)
	ProceedLine( buf );

#ifdef ADDBAR
	if (falwaysaddbar)
	{
	  MakeBar( bar, NULL );
	  fprintf(cgiOut, "%s", bar );
	}
#endif

  }
  else {
	  while(fgets(buf, LARGEBUFLEN, fd)!=NULL)
	fprintf(cgiOut, "%s", buf );
  }

  fclose(fd);
  return TRUE;
  /* konec EncodeHTTP */
}

#endif

#ifdef ADDBAR

int SetBarDef()
{

#ifdef LONGNAMEBAR
	barsep[0] = '='; barsep[1] = '\0';
	flongname = 1;
#else
	barsep[0] = '\0';
	flongname = 0;
#endif

#ifdef ALWAYSADDBAR
	falwaysaddbar = 1;
#else
	falwaysaddbar = 0;
#endif

#ifdef ADDWHICHCODE
	faddwhichcode = 1;
#else
	faddwhichcode = 0;
#endif

	fenglish = 0;
	ftitle = 1;
	fback = 1;

	return 1;
}

#endif

int cgiMain( int argc, char * argv[])
{
	char *b, buf[LARGEBUFLEN];

	/*	signal( SIGALRM, alarmtrap );*/

	/* ziskani typu vysledneho kodovani ze jmena, pod kterym byl spusten */
	script_name = cgiScriptName;
	b = script_name;
	if ( b == NULL )
	{
		/* nepodarilo se ziskat jmeno beziciho scriptu */
		http_perr( "C-SaCzech: Server error" );
		fprintf(cgiOut, "Environment variable SCRIPT_NAME not set.\n");
		return 0;
	}
	strcpy( buf, b );
	b = strrchr(buf, '/');
	if ( b == NULL ) b = buf; /* pokud jmeno neobsahuje lomitko je jmeno od startu */
	else b++;		     /* jinak zmen b, aby ukazovalo za lomitko jinak az za lomitkem*/
	if (strstr(b, "to")==b) b+=2;  /* odstraneni predpony 'to' pokud je */
	/* nakopiruj jmeno scriptu do promenne pname */
	strcpy( pname, b );

#ifdef CGISUFFIX
	/* pokud je scipt s priponou umaz ji, pokud je jina nic se nestane */
	b = strstr( pname, CGISUFFIX );
	if ( b!=NULL ) *b = '\0';
#endif


	/* zjisteni indexu zdrojoveho a ciloveho kodovani */
	/* zdrojove je z defaultniho nastaveni promenne DEFSOURCE a cilove
	je ze jmena souboru */
	source = whichcode( DEFSOURCE );
	target = whichcode( pname );

	/* otestovani, zda surce a target jsou platne kody */
	if ( source == -1 || target == -1 )
	{
		http_perr( "C-SaCzech: Bad code name");
		if ( target == -1 )
			/* vada je u ciloveho kodovani */
			sprintf( buf, "Bad script name %s - no valid code name.", argv[0] );
		else
			/* vada je u zdojoveho kodovani */
			sprintf( buf, "Default code name set badly - %s. Contact \
administrator of the requested page.", DEFSOURCE );
			http_perr( buf );
		/* ukonci beh prohramu */
		return 0;
	}

	/* ziskani korektniho query a pokud existuje, pridani '?' na zacatek */
	/* standardne neni query vyplnena pokud pouzivam volani typu : "cp150.exe/default.htm" */
	b = cgiQueryString;
	if ( b != NULL && b[0] != '\0' )
	{
		sprintf( query, "?%s", b );
		/* nahradi promnnou "__CHARSET__" za platne jmeno sady */
		subs( query, "__CHARSET__", TRUENAME(target) );

#ifdef DECODEQUERY
		/* dekoduj i pro jine cgi scipty */
		EncodeLine(query);
#endif
	}

	/* nastaveni defaultniho vypisovani BARu, podle definovanych promennych */
#ifdef ADDBAR
	SetBarDef();
#endif

#ifdef MULTIPART
	/* zjisti, kterou cast dokumentu ma zobrazit podle nazvu pod kterym */
	/* byl spusten */
	{
		char *a;
		int i;

		partname[0] ='\0';
		/* pouzij jmeno spusteneho programu vcetne cesty */
		a = strchr( argv[0], '.' );
		/* najdi tecku co oddeluje suffix */
		b = strrchr( argv[0], '.' );
		if ( a != NULL
#ifdef CGISUFFIX
			 && a != b )
		{ a++; for( i=0; a != b ; i++ ) partname[i] = *(a++); }
#else
		  )
		{ a++; for( i=0; *a != '\0'; i++ ) partname[i] = *(a++); }
#endif
	}

#endif

/* nutno presunout pred EncodeFile, promenna neni jinak definovana */
/*#if defined(http) || defined(guess)*/
	path_info = cgiPathInfo;
/*#endif*/


#ifdef file
	EncodeFile();
#endif

#ifdef http
	EncodeHTTP( env );
#endif

#ifdef guess
	if ( path_info == NULL )
	{
		http_perr("C-SaCzech: No path given");
		fprintf(cgiOut,"You must specify which page I have to translate.");
		return 0;
	}

	if ( strstr( path_info, CGIPATH ) == path_info
#ifdef CGISUFFIX
		 || strstr( path_info, CGISUFFIX )
#endif
		)
		  EncodeHTTP( env );
	else
		  EncodeFile();
#endif
	return 0;
}

