/*
 * Par funkce a procedur uzitecnych pri praci s html formami
 * taky prostredky pro http kontakt 
 * - Rahen
 */

#ifndef WWW_H_RAHEN

#define WWW_H_RAHEN

#define LINE_LEN		2048
#define PATH_LEN		1024
#define QUERY_LEN		512

#define TIMEOUT			60
#define WWW_STD_PORT		80

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h> 
#include <sys/stat.h>
#include <string.h>
#include <ctype.h>
/*#include <unistd.h>*/
#include <errno.h>

#define MAXQUEUED	5

/* Socket and TCP/IP stuff */
/* tohle bohuzel v NT neni */
#include <fcntl.h>
/*#include <netdb.h>*/
/*#include <netinet/in.h>*/
/*#include <sys/socket.h>*/
/*#include <arpa/telnet.h>*/

#ifdef sun
int gethostname (char *name, int namelen);
#endif

unsigned long inet_addr(char *cp);

#if !defined(FALSE)
#define FALSE 0
#endif

#if !defined(TRUE)
#define TRUE 1
#endif

#define LOWER(c)	( (c) >= 'A' && (c) <='Z' ? (c) - 'A' + 'a' : (c) )
#define UPPER(c)	( (c) >= 'a' && (c) <='z' ? (c) - 'a' + 'A' : (c) )
#define UMIN(x,y)   ( (x) < (y) ? (x) : (y) )
#define UMAX(x,y)   ( (x) > (y) ? (x) : (y) )

#define S_ISDIR(m)	((m) & S_IFDIR)
#define S_ISREG(m)	((m) & S_IFREG)

/* test zda dana cesta ukazuje na soubor */
int isfile( char *name )
{
   struct stat buf;

   stat( name, &buf );
   return ( S_ISREG(buf.st_mode) );
}

/* test zda dana cesta ukazuje na adresar */
int isdir( char *name )
{
   struct stat buf;

   stat( name, &buf );
   return ( S_ISDIR(buf.st_mode) );
}

int cat(char * path)
{
   FILE *fd;
   char buf[2048];

   if ( ( fd = fopen( path, "r" ) ) == NULL )
	return FALSE;

   while(!feof(fd))
   {
      fgets(buf, 2048, fd);
      printf(buf);
   }
   return TRUE;
}


/* 
 * vraci pointer na b2 v b1; jinak NULL
 */
char * strcaseinfix( const char *b1, const char *b2 )
{
    const char *ach,*bch;

    if ( b1 == NULL || b2 == NULL || b2[0] == '\0' )
        return NULL;

    /* prochazi retezec, pokud narazi na znak, kterym zacina b2, otestuje */
    /* jestli tam nahodou neni obsazeny cely b2 */
    for ( ; *b1 != '\0'; b1++ )
    {
        if ( UPPER(*b1) == UPPER(b2[0]) )
		  {
          for( ach=b1, bch=b2; (*bch != '\0') && (*ach != '\0') ; ach++,bch++ )
          {
             if ( UPPER(*ach) != UPPER(*bch) )
                     break;
          }
          if ( *bch == '\0' ) return (char *) b1;
        }
    }

    return NULL;
}


/*
 * vraci true, pokud je s2 zacatkem s1, false jinak
 */
int str_prefix( const char *s1, const char *s2 )
{
   int i;
   
   if ( !s1 || !s2 ) return (!s2);

   i = 0;
   while( s1[i] == s2[i] && s1[i] != '\0' && s2[i] != '\0' ) i++;

   return (s2[i] == '\0');
}


/*
 * vraci char, na jehoz kod ve tvaru XX ukazuje what
 * pouziva se pro nahrazeni ESC sekvence %xy odpovidajicim znakem
 */
char x2c(char *what) 
{
    register char digit;

	 digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A')+10 : (what[0] - '0'));
	 digit *= 16;
	 digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A')+10 : (what[1] - '0'));
    return(digit);
}

/*
 * v retezci prevede vsechny sequence %xy na znak, ktery predstavuji
 */

void hex2dec( char * hmm )
{
   register int x,y;

   for(x=0,y=0;hmm[y];++x,++y) {
      if( (hmm[x] = hmm[y] ) == '%' ) 
      {
         hmm[x] = x2c(&hmm[y+1]);
			y+=2;
      }
   }
   hmm[x] = '\0';
}
 

/*
 * zmena vsech '+' na mezery
 */
void plus2space(char *str) 
{
    register int x;

	 for(x=0;str[x];x++) if(str[x] == '+') str[x] = ' ';
}


/* 
 * nacteni casti retezce po znak 'sep' - znak 'sep' se ignoruje a 
 * nactena cast se z query vymaze
 */

int get_pparam( char *query, char *pparam, char sep )
{
   int i=0,j;
   char *p,*q;

	if ( query == NULL || query[0] == '\0') return FALSE;
   j = strlen( query );
   p = query;

   for( ; (i<j) && *query != sep ; i++ )
      *(pparam++) = *(query++);

   *pparam = '\0';
   q = query;
   if ( *q != '\0' ) q++;
   for( ; (i<=j) ; i++ )
         *(p++) = *(q++);

   return TRUE;
}


/*
 * Podle nastaveni vraci bud cast pred = nebo za
 * pparam tedy po volani procedury obsahuje novy text; stary je 
 * nenavratne ztracen
 */

int split_pparam( char * pparam, int front, char sep )
{
   char *q;

   q = strchr( pparam, sep );
	if ( q == NULL ) return FALSE;

   if (front)
      *q = '\0';
   else
   {
      q++;
      strcpy( pparam, q );
   }

   return TRUE;
}


/*
 * nahradi v retezci 'line' vyskyt retezce 'co' obsahem retezce 'cim'
 * bacha muze zkoredumpovat proces, pokud je 'cim' vetsi nez 'co'
 * a v 'line' neni dost mista
 */

int subs( char * line, const char *co, const char *cim )
{
	char *b, buf[512];
	int i;

	if ( line == NULL || co == NULL || cim == NULL )
	return -1;

	b = line; i = strlen( co );

	while( ( b = strstr( b, co ) ) != NULL )
	{
		strcpy( buf, b );
		strcpy( b, cim );
		strcat( b, buf+i*sizeof(char) );
	}
	return TRUE;
}

static timeout=TIMEOUT;

/*
int connect_server( char *address, int port )
{
  struct sockaddr_in sa;
  struct hostent * hp;
  int sock;

  if ((hp = gethostbyname(address)) == NULL) /* do we know the host's */
/*  {
	  /* address? */
/*	  return(-1); /* no */
/*  }

  if ((sock = socket(AF_INET,SOCK_STREAM,0)) < 0) /* get socket */
/*	return(-1);

  memset(&sa,'\0',sizeof(sa));
  memcpy((char *)&sa.sin_addr,hp->h_addr, hp->h_length);

  sa.sin_family= AF_INET;
  sa.sin_port= htons((u_short)port);

  alarm( timeout );
  if (connect(sock,(struct sockaddr *)&sa,sizeof(sa)) < 0) /* connect */
/*  { close(sock); return(-1); }

  return sock;
} */

#endif
